<?php
require_once("lib-action/action.php");
use Billing\Skin;

class AddClient extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

        require_once("objects/Transaction.php");
		$this->smartyVars["paymentList"] = Transaction::payment_types();
        require_once("objects/Client.php");
		$this->smartyVars["statusList"] = blmsg_array(Client::statuses());
		$this->mergeLanguageData($CONF["user"]["locale"]->language);
		$this->mergeCountryData();
        require_once("objects/EmailTemplateGroup.php");
		$this->smartyVars["emailActions"] = blmsg_array(EmailTemplateGroup::types());
		require_once("objects/Client.php");
		foreach (Client::types() as $key => $type) {
			$this->smartyVars["clientTypes"][$key] = blmsg($type);
		}

		$this->mergeThemeData();

		$formDefaults = array(
			"clientActive" => 1,
			"countriesID" => $this->smartyVars["selectedCountry"],
			"languageID"  => $this->smartyVars["selectedLanguage"],
			"contactEmailFormat" => 1,
		);
		$this->smartyVars['attributeGroups'] =array();
        foreach(Factory()->AttributeGroupList(array("vendor_id" => getCurrentSession()->getVendorId(), "group_active" => 1)) as $group) {
            $this->smartyVars['attributeGroups'][$group->group_id] = $group->group_name;
        }

		$this->smartyVars["billingAccountTypes"] = $CONF["types"]["billingAccount"];
		unset($this->smartyVars["billingAccountTypes"][getAPITypeID("billingAccount", "hspcbanktransfer")]);
		$this->smartyVars["bankAccountTypes"] = $CONF["types"]["bankAccount"];
		$this->smartyVars["cardTypes"] = $CONF["types"]["card"];
		$this->smartyVars["cardExtraTypes"] = $CONF["types"]["cardExtraIDs"];

		require_once("object_managers/CryptManager.php");
		$this->smartyVars["needKey"] = CryptManager::isEncryptionEnabled() && !CryptManager::isLekEnabled() ? true : false;

		$this->mergeFormState($formDefaults);

		require_once("Skin.php");
		$this->smartyVars["skinList"] = Skin::getSkins();
		if (! isset($this->smartyVars["formValues"]["skinID"]))
			$this->smartyVars["formValues"]["skinID"] = Skin::DEFAULT_SKIN_ID;

        $this->smartyVars["billingSecureUrl"] = billing_base_url();
        $this->smartyVars["permissionCustomerGroups"] = true;
        if ($this->_isReseller()) {
            $this->smartyVars["permissionCustomerGroups"] = $this->_getReseller()->hasPermission(Reseller::PERMISSION_CUSTOMER_GROUPS);
        }
		$this->addTemplate("clients/AddClient", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}