<?php

require_once("lib-action/action.php");

class EditBasicClientAttributes extends MB_Action
{

	public function __construct()
    {
		parent::__construct();
		$this->params = array("clientID");
	}

	public function execute()
    {
		parent::execute();

		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {
            $customer = Factory()->Client($clientID);
            $this->_setResellerTemplateVariables($customer);
			$client = oneById("clients", $clientID, array("mergePrimaryContact" => 1));
            $keyedAttributes = optionsFor("attributes", array());
			$namedAttributes = array_flip($keyedAttributes);
            require_once('objects/GroupAttributes.php');
            $attributeGroups = $attributeGroupValues = array();
            foreach(Factory()->AttributeGroupList(array("vendor_id" => getCurrentSession()->getVendorId(), "group_active" => 1)) as $group) {
                $attributeGroups[$group->group_id] = $group->group_name;
                $attributeGroupValues[$group->group_id] = array(
                    GroupAttributes::MAXIMUM_DISCOUNT => !is_null($group->GroupAttributes[GroupAttributes::MAXIMUM_DISCOUNT]->value) ? $group->GroupAttributes[GroupAttributes::MAXIMUM_DISCOUNT]->value : "" ,
                    GroupAttributes::MINIMUM_DISCOUNT => !is_null($group->GroupAttributes[GroupAttributes::MINIMUM_DISCOUNT]->value) ? $group->GroupAttributes[GroupAttributes::MINIMUM_DISCOUNT]->value : "" ,
                );
                if (!is_null($value = $group->GroupAttributes[GroupAttributes::SUSPENTION_EXEMPT]->value)) {
                    $attributeGroupValues[$group->group_id][GroupAttributes::SUSPENTION_EXEMPT] = (1 == $value)
                        ? blmsg("TRANS_YES")
                        : blmsg("TRANS_NO");
                } else {
                    $attributeGroupValues[$group->group_id][GroupAttributes::SUSPENTION_EXEMPT] ="";
                }
            }
            $this->smartyVars["attributeGroups"] = $attributeGroups;
            $this->smartyVars["attributeGroupValues"] = $attributeGroupValues;
            $this->smartyVars["suspentionExemptAttribute"] = GroupAttributes::SUSPENTION_EXEMPT;

            require_once('objects/GroupAttributes.php');
            $programaticAttributes = GroupAttributes::types();
			$defaultAttrs = array_keys($programaticAttributes);
			foreach ($defaultAttrs as $attrName){
				if (!$namedAttributes[$attrName]){
					$namedAttributes[$attrName] = "x";
				}
			}
            ksort($namedAttributes);
			$this->smartyVars["customerGroupAttributes"] = array_intersect_key($namedAttributes, $programaticAttributes);
			$this->smartyVars["namedAttributes"] = array_diff_key($namedAttributes, $programaticAttributes);
			$this->smartyVars["programaticAttributes"] = $programaticAttributes;
			$clientAttributes = arrayFor("clientAttributes", array("clientID" => $clientID));

			$this->smartyVars["attributeValues"] = array();
			foreach ($clientAttributes as $attr){
				$this->smartyVars["attributeValues"][$attr["attributeID"]] = $attr;
			}

			$this->smartyVars["client"] = $client;
			$this->mergeFormState($client);
			$this->addTemplate("clients/EditBasicClientAttributes", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
