<?php

require_once("lib-action/genericactions.php");

class EditClientResponse extends EditResponseAction
{
	public function __construct()
	{
		// prevent an admin from forcing the clientActive variable outside of the edit form
		unset($_REQUEST["clientActive"]);
		$clientID = bgpc("clientID");
		$clientStatus = bgpc("clientStatus");
		$this->_client = Factory()->Client($clientID);
		// check number of accounts in licence.
		require_once("object_managers/ClientManager.php");
		if (
			(Client::STATUS_ACTIVE == $clientStatus || Client::STATUS_SUSPENDED == $clientStatus)
			&&	(Client::STATUS_ACTIVE != $this->_client->client_status || Client::STATUS_SUSPENDED != $this->_client->client_status)
			&&	ClientManager::reachedLicenceAccountsNumberLimit()
		) {
			billing_put_error(blmsg(
				"TRANS_CUSTOMER_CANT_ACTIVATE_LICENSE_LIMIT_EXCEEDED_MSG",
				array("NAME" => $this->_client->PrimaryContact->contact_fullname)
			));
			redirect("clients.php", getActionID("EditClient"), array("clientID" => $clientID));
		}
		$this->d = new DataSource("clientsGeneric");
		parent::__construct();
	}

	public function editResponseHandler()
	{
		$clientID = bgpc("clientID");

		// update sync status
		$customer = new Client($clientID);
		if (!$customer->isReseller()) {
			$customer->sync_tasks |= Client::SYNC_NEED_UPDATE;
			$customer->update();
		}

		require_once("object_managers/SecurityManager.php");
		SecurityManager::pushCurrentActionIntoLog(
			SecurityManager::USER_TYPE_CLIENT,
			$clientID,
			$this->_client->PrimaryContact->contact_username,
			"TRANS_ACTION_LOG_REASON_EDIT_USER",
			blmsg("TRANS_ACTION_LOG_COMMENT_CLIENT", array("CLIENT_ID" => $clientID), SecurityManager::getActionLogLocale())
		);
		return true;
	}

	private $_client = null;
}
