<?php

require_once("lib-action/genericactions.php");

class RemoveAttributeGroupResponse extends RemoveResponseAction
{
	public function __construct()
	{
		parent::RemoveResponseAction();
		$this->setDataSource(new DataSource("attributeGroups"));
        $groupID = bgpc("groupID");
        if (is_null($reseller = $this->_getReseller()) && in_array($groupID, array(Settings()->defaultCustomerGroupID, Settings()->defaultResellerGroupID))) {
            throw new ForbiddenOperationException("Removal of default reseller and customer groups is restricted.");
        } elseif ($groupID == $reseller->default_attribute_group_id) {
            throw new ForbiddenOperationException("Removal of default customer group is restricted.");
        }
	}

	public function RemoveResponseParamHandler()
	{
		$groupID = bgpc("groupID");
		foreach (Factory()->ClientList(array("group_id" => $groupID)) as $client) {
			$client->group_id = Settings()->defaultCustomerGroupID;
			$client->update();
		}
		return true;
	}
}
