<?php
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This class is a child class of MB_Action. It will display a mini client report using the reports wizard.
 *
 * @author  Michael Fountain
 */
class ShowClientStats extends MB_Action {
	/**
	 * The constructor for a ShowClientStats action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowClientStats() {
		parent::MB_Action();
		$this->stringRep = "ShowClientStats";
		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ShowClientStats action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        require_once 'objects/Client.php';
        require_once 'object_managers/ClientManager.php';
        
        $statisticByStatus = ClientManager::getStatusStatistics(getCurrentSession()->getVendorId());
        $templateElements = array();
        $templateElements["statusLabels"] = Client::statuses();
        $templateElements["statusValues"] = $statisticByStatus;
        $templateElements["statusTotal"] = array_sum($statisticByStatus);

        $this->addTemplate("clients/ShowClientStats", collapseArrayElements($templateElements), 1);
        
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}