<?php

class Companies_IndexController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		if("ShowDashboard" == bgpc("redirectAction")) {
			$this->_backUrl = $this->view->ActionUrl('dashboard', 'ShowDashboard');
		} else {
			$this->_backUrl = $this->view->adminActionUrl('configs', 'system', 'show');
		}
	}

	public function indexAction()
	{
		$this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_SETTINGS_COMPANY'));
		if ($reseller = getCurrentSession()->getReseller()) {
			$company = Factory()->Company($reseller->company_id);
		} else {
			require_once 'object_managers/CompanyManager.php';
			$company = CompanyManager::getProviderCompany();
			$reseller = null;
		}
        $form = new Billing_Zend_Form_Final_CompanyForm(
        	$company,
        	$reseller,
			array(
				'cancelUrl' => $this->_backUrl
			)
        );
		if ($this->_request->isPost()) {
			try {
				if (!$form->isValid($this->_request->getPost())) {
					throw new ProductException(ProductException::E_FAIL_OPERATION, $this->_translator->translate('TRANS_SETTINGS_COMPANY_INVALID'));
				}
				$form->process();
				$message = $this->view->translate('TRANS_SETTINGS_COMPANY_SUCCESS_EDIT');
				$this->_redirectWithMessage($this->_backUrl, $message);
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}

		}
		$this->view->form = $form;
    }

    private $_backUrl = NULL;
}