<?php

require_once("lib-action/action.php");

class ShowSystemOverview extends MB_Action
{
	public function execute()
	{
		parent::execute();
        
        $vendorId = getCurrentSession()->getVendorId();
        
        require_once("objects/Client.php");
		require_once("object_managers/ClientManager.php");
		$customerStatusStat = ClientManager::getStatusStatistics($vendorId);
		$this->smartyVars["customers"]["active"] = $customerStatusStat[Client::STATUS_ACTIVE];
		$this->smartyVars["customers"]["pending"] = $customerStatusStat[Client::STATUS_PENDING];

		require_once("object_managers/PackageManager.php");
		require_once("objects/Package.php");
		$subscriptionTypeStat = PackageManager::getTypeStatistics(array(Package::STATUS_ACTIVE));
		$this->smartyVars["subscriptions"]["active"] = array_sum($subscriptionTypeStat);
		require_once("objects/Product.php");
		$this->smartyVars["subscriptions"]["hosting"] = $subscriptionTypeStat[Product::TYPE_HOSTING];
		$this->smartyVars["subscriptions"]["domain"] = $subscriptionTypeStat[Product::TYPE_DOMAIN];
		$this->smartyVars["subscriptions"]["ssl"] = $subscriptionTypeStat[Product::TYPE_SSL_CERT];
		$this->smartyVars["subscriptions"]["sslFactory"] = $subscriptionTypeStat[Product::TYPE_CERT];

		require_once("object_managers/InvoiceManager.php");
		$this->smartyVars["invoices"] = InvoiceManager::getDueStatistics();
		$this->smartyVars["invoices"]["due_date"] = BillingLocale::getDateShort(time());
		$this->smartyVars["invoices"]["overdue_date"] = BillingLocale::getDateShort(time() + 24*60*60);
		$this->smartyVars["invoices"]["due_min"] = BillingLocale::getDecimal(0.01);

        if (!$vendorId) {
            require_once("objects/Reseller.php");
            require_once("object_managers/ResellerManager.php");
            $resellerStatusStat = ResellerManager::getStatusStatistics($vendorId);
            $this->smartyVars["resellers"]["active"] = $resellerStatusStat[Reseller::STATUS_ACTIVE];
            $this->smartyVars["resellers"]["pending"] = $resellerStatusStat[Reseller::STATUS_PENDING];

            $this->smartyVars["subscriptions"]["reseller"] = $subscriptionTypeStat[Product::TYPE_RESELLER];
        }

		$this->addTemplate("dashboard/ShowSystemOverview");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
