<?php

require_once("lib-action/action.php");

class ShowSystemSetup extends MB_Action
{
	public function execute()
	{
		parent::execute();
		$vendorId = getCurrentSession()->getVendorId();
        $this->smartyVars["vendorId"] = !is_null($vendorId) ? $vendorId : 'null';
		$reseller = $this->_getReseller();
		
		$this->smartyVars["showEncriptionSettings"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_ENCRIPTION_SETTINGS) : true;
		$this->smartyVars["showTaxationPolicies"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_TAXATION_POLICIES) : true;
		$this->smartyVars["showPaymentGateways"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_PAYMENT_GATEWAYS) : true;
		$this->smartyVars["showDomainRegistrars"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_REGISTRARS) : true;
		$this->smartyVars["showFraudStatus"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_FRAUD_PROTECTION) : true;
		$this->smartyVars["showCompanyDetails"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_COMPANY_INFO) : true;
		
		$this->smartyVars["paymentGateways"]["status"] = (0 == count(Factory()->PaymentGatewayList(array('vendor_id' => $vendorId)))) ? "not-configured" : "done";

		require_once("object_managers/BillingRegistrarManager.php");
		
		$this->smartyVars["registrars"]["status"] = sizeof(BillingRegistrarManager::getEnabledRegistrars($vendorId)) ? "done" : (sizeof(BillingRegistrarManager::getDisabledRegistrars($vendorId)) ? "not-managed" : "not-configured");

		$this->smartyVars["taxes"]["status"] = (0 == count(Factory()->TaxZoneGroupList(array('vendor_id' => $vendorId)))) ? "not-configured" : "done";

		$this->smartyVars["fraud"]["status"] = isset(Settings()->fraudSecurityLevel) ? "done" : "not-configured";
		$this->smartyVars["company"]["status"] = Settings()->settings_isCompanyDetailsConfigured ? "done" : "not-configured";

		require_once("object_managers/CryptManager.php");
		$this->smartyVars["encryption"]["status"] = (CryptManager::isEncryptionEnabled()) ? "done" : "not-configured";

		$this->smartyVars["warningHide"] = bgpc("dashboard-system-setup-warning-hide-{$this->smartyVars["vendorId"]}", 0);


		$this->addTemplate("dashboard/ShowSystemSetup");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
