<?php
require_once ("lib-action/action.php");

class ShowEmailQueue extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$tools_panel = UIFactory()->ToolsPanel(blmsg("TRANS_TOOLS"));

        if (!$this->_isReseller() || ($this->_isReseller() && $this->_getReseller()->hasPermission(Reseller::PERMISSION_EMAIL_TEMPLATES))) {
            $tools_panel->addButton(UIFactory()->ToolButton( "email-template-groups", blmsg("TRANS_EMAIL_TEMPLATE_GROUPS"), action_url("emails", "ShowEmailTemplateGroups") ));
        }

		$tools_panel->addButton(UIFactory()->ToolButton( "send-emails", blmsg("TRANS_SEND_EMAILS"),	action_url("events", "SendEmails") ));
		$page  = UIFactory()->Page();
		$page->addToolsPanel($tools_panel);
		$page->title = blmsg("TRANS_SHOW_EMAILS");

		if (!is_null( $client_id = bgpc("clientID") ))
		{
			$client = Factory()->Client($client_id);
			$page->parent_title = $client->PrimaryContact->contact_fullname;
			$page->parent_url = action_url("clients", "ShowClientDetails", array("clientID"	=> $client_id));
		} else {
			$page->parent_url = action_url("dashboard", "ShowDashboard");
		}

		require_once("UI/List/UIEmailList.php");
		$page->addListPanel(new UIEmailList( $client_id ));

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}
