<?php
class Invoices_CustomizationInvoiceFacturaController extends Billing_Zend_Controller_Action_AdminController
{
	public function editAction()
	{
		$this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_CUSTOMIZATION_INVOICE_FACTURA_SETTINGS'));
		$formOptions = array(
			'cancelUrl' => $this->view->AdminActionUrl('configs', 'system', 'show')
		);

		$form = new Billing_Zend_Form_Final_EditCustomizationInvoiceFacturaForm($formOptions);
		if ($this->_request->isPost()) {
			try {
				if (!$form->isValid($this->_request->getPost())) {
					throw new ProductException(ProductException::E_FAIL_OPERATION, $this->_translator->translate('TRANS_RESELLER_PROFILE_INVALID'));
				}
				$form->process();
				$this->_redirectWithMessage(
					$this->view->AdminActionUrl('configs', 'system', 'show'),
					$this->_translator->translate('TRANS_SETTINGS_SAVED_SUCCESSFULLY')
				);
			} catch (ProductException $exception) {
				$this->_status->addError($exception->getMessage());
			}
		}

		$this->view->form = $form;
	}
}