<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 *
 * @author  Kris Bailey
 */
class ReplayCallbackLog extends MB_Action {
	/**
	 * The constructor for a ReplayCallbackLog action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ReplayCallbackLog() {
		parent::MB_Action();
		$this->stringRep = "ReplayCallbackLog";
	}

	/**
	 * The main method of this class that executes the ReplayCallbackLog action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();
		
        $callbackLogID = (int)$_REQUEST["callbackLogID"];
		if (!$callbackLogID) {
			$this->addError(TRANS_ACTIONERROR, "No callback log ID given.");
		} else {
            require_once 'object_managers/PaymentGatewayManager.php';
            $vendorId = getCurrentSession()->getVendorId();
            $paymentGatewayList = PaymentGatewayManager::getPaymentGatewayIdsByVendorId($vendorId);
            if (null == $vendorId) {
                $paymentGatewayList[] = null;
            }
            $callback = reset(Factory()->CallbackList(array('callback_log_id' => $callbackLogID, 'payment_gateway_id' => $paymentGatewayList)));
            if (empty($callback)) {
                $this->addError(TRANS_ACTIONERROR, "Callback not found.");
            } else {
                $this->smartyVars["callbackLogID"] = $callback->callback_log_id;
                $this->smartyVars["isUserExist"] = reset(Factory()->ClientList(array('client_id' => $callback->client_id)));
                $this->smartyVars["callbackLogInfo"] = $this->_convertObjectToArray($callback);
                if (null !== $callback->transaction_id) {
                    $transaction = Factory()->Transaction($callback->transaction_id);
                    $this->smartyVars["transactionLog"] = $this->_convertObjectToArray($transaction);
                }
                
                $this->addTemplate("paymentqueue/ReplayCallbackLog");
            }
        }
		$this->addErrorTemplates();

		return $this->hasExecutedSuccessfully();
	}
}