<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 *
 * @author  Kris Bailey
 */
class ReplayCallbackLogResponse extends MB_Action {
	/**
	 * The constructor for a ReplayCallbackLog action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ReplayCallbackLogResponse() {
		parent::MB_Action();
		$this->stringRep = "ReplayCallbackLogResponse";
	}

	/**
	 * The main method of this class that executes the ReplayCallbackLogResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$callbackLogID = (int)$_REQUEST["callbackLogID"];
		if (!$callbackLogID){
			$this->addError(TRANS_ACTIONERROR, "Invalid callback log id passed.");
		} else {
		
			$callbackLogInfo = oneByID("callbackLogs", $callbackLogID);
		
			$createClientRecord = ($_REQUEST["replayAction"]=="create")?1:0;
			$overrideClientID = ($_REQUEST["replayAction"]=="use")?(int)$_REQUEST["clientID"]:0;

            $replayResult = dispatchMBAPI(toXML(array(
                "mbapi" => array(
                    "command" => "ProcessCallbackReplay",
                    "params" => array(
                        "callbackLogID" => $callbackLogID,
                        "gatewayName" => getAPITypeName("callbackLog", $callbackLogInfo["callbackLogType"]),
                        "createClientRecord" => $createClientRecord,
                        "overrideClientID" => $overrideClientID,
                    ),
                ),
            )), 1);
            
            if (!empty($replayResult['mbapi'][0]['header'][0]['errorCount'][0])) {
                $this->addError(TRANS_ACTIONERROR, $replayResult['mbapi'][0]['header'][0]['errors'][0]['error'][0]['title'][0]);
            } else {
                // have to get the info again in case the client id got updated to forward to the right place
                $callbackLogInfo = oneByID("callbackLogs", $callbackLogID);

                if ((int)$callbackLogInfo["clientID"]){
                    redirect("clients.php", "ShowClientDetails", array(
                        "clientID" => $callbackLogInfo["clientID"],
                    ));
                } else {
                    redirect("paymentqueue.php", "ShowCallbackLog");
                }
            }
		}
        unset($_REQUEST['clientID']);
        
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}