<?php
require_once ("lib-action/action.php");
require_once ("admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class EditLedgerGroupEntries extends MB_ProductAction
{

	public function __construct()
    {
		parent::__construct("ledgergroups");
	}

	public function execute()
    {
		parent::execute();

		if ((int)$_REQUEST["productVariantID"]){
		 	$this->smartyVars["productVariantID"] = (int)$_REQUEST["productVariantID"];
		}
		$this->smartyVars["ledgerGroupID"] = (int)$_REQUEST["ledgerGroupID"];

		$variantInfo = oneByID(":productVariants", $this->smartyVars["productVariantID"]);

		$q = new MBQuery("GetProducts", "", array("productID" => $variantInfo["productID"], "getCouponData" => 1, "getPreCouponData" => 1));
		$r =& $q->getResult();
		$s =& $r->getSubjectFrom(
			array("mbapi", "results", "products", "product", 0),
			"productID", "productName"
		);
		$productInfo = $s->getEssential();
		$product = $s->getCollapsed();

		$this->smartyVars['product'] = $product;
		$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
			"productID" => $_REQUEST["productID"] = $product["productID"],
		));

		$this->setupTypeButtons($product["productType"]);
		$this->smartyVars["productButtons"] = $this->productButtons->getButtons();


		$this->addLedgerAccounts();
		
		// get available currencies
		$currencyIDs = array();
		foreach (Factory()->OrderFormList(array('vendor_id' => getCurrentSession()->getVendorId())) as $store) {
			$currencyIDs[$store->currency_id] = $store->currency_id;
		}
		$this->smartyVars["currencyIDs"] = $currencyIDs;
		
		$this->smartyVars["selectableCurrencies"] = $this->smartyVars["currencyIDs"];
		$this->smartyVars["selectableCycles"] = getCyclesArray();
		$this->smartyVars["selectedCurrencies"] = array();
		$this->smartyVars["selectedCycles"] = array();

		if ((int)$_REQUEST["ledgerGroupID"]){
			$data = dispatchMBAPI("<mbapi><command>GetLedgerGroups</command><params><ledgerGroupID>".(int)$_REQUEST["ledgerGroupID"]."</ledgerGroupID></params></mbapi>", 1);
			$data = collapseArrayElements($data["mbapi"][0]["results"][0]["groups"][0]["group"]);
			dbg("group info:");
			dbg($data);
			if (isset($data["ledgerEntries"]["entry"]["productVariantID"])){
			 	$data["ledgerEntries"]["entry"] = array($data["ledgerEntries"]["entry"]);
			}
			$this->smartyVars["existingEntries"] = $data["ledgerEntries"]["entry"];
			foreach ($this->smartyVars["existingEntries"] as $k=>$v){
				$this->smartyVars["existingEntries"][$k]["generalLedgerDebitAmount"] = $v["productLedgerDebit"];
				$this->smartyVars["existingEntries"][$k]["generalLedgerCreditAmount"] = $v["productLedgerCredit"];
				$this->smartyVars["existingEntries"][$k]["generalLedgerDescription"] = $v["productLedgerComment"];
			}
			$productLedgerID = $data["ledgerEntries"]["entry"][0]["productLedgerID"];

			$query = "<mbapi><command>GetProductLedgerEntries</command><params><productLedgerID>".$productLedgerID."</productLedgerID><getProductLedgerCurrenyIDs>1</getProductLedgerCurrenyIDs><getProductLedgerCycleIDs>1</getProductLedgerCycleIDs></params></mbapi>";
			$ledata = dispatchMBAPI($query, 1);
			$setCycles = array();
			$setCurrencies = array();

			dbg("ledger data");
			dbg($ledata);
			if (isset($ledata["mbapi"][0]["results"][0]["productLedgerEntries"][0]["productLedgerEntry"][0])) {
				$ledata = $ledata["mbapi"][0]["results"][0]["productLedgerEntries"][0]["productLedgerEntry"][0];
				$this->smartyVars["currencyID"] = $ledata["currencyID"][0];
				if (isset($ledata["currencies"][0]["currency"][0]["currencyID"])) {
				 	foreach ($ledata["currencies"][0]["currency"] as $curr) {
				 	 	$setCurrencies[$curr["currencyID"][0]] = $curr["currencyID"][0];
					}
				}
				if (isset($ledata["cycles"][0]["cycle"][0]["cycleID"])){
				 	foreach ($ledata["cycles"][0]["cycle"] as $cycle){
				 	 	$setCycles[$cycle["cycleID"][0]] = $cycle["cycleID"][0];
					}
				}
			}
			foreach ($this->smartyVars["selectableCurrencies"] as $v){
				if (isset($setCurrencies[$v])){
				 	$this->smartyVars["selectedCurrencies"][$v] = $v;
					unset($this->smartyVars["selectableCurrencies"][$v]);
				}
			}
			foreach ($this->smartyVars["selectableCycles"] as $k=>$v){
			 	if (isset($setCycles[$k])){
			 	 	$this->smartyVars["selectedCycles"][$k] = $v;
					unset($this->smartyVars["selectableCycles"][$k]);
				}
			}

		}

		if (isset($this->smartyVars["existingEntries"][0]["ledgerGroupName"])){
			$this->smartyVars["ledgerGroupName"] = $this->smartyVars["existingEntries"][0]["ledgerGroupName"];
		}

		$this->addTemplate("widgets/products/EditLedgerGroupEntries", $this->smartyVars);


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
