<?php
require_once("lib-action/action.php");

class RemoveProductResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();
		
		$productID = ((int) $_REQUEST["productID"]);
		if(!$productID) {
			getCurrentSession()->Storage->errorMessages[] = blmsg("TRANS_PLAN_ERROR_REMOVE_EMPTY_ID");
			redirect("products.php", "ShowProducts");
			return;
		}

		$plan = Factory()->Product($productID);
		$planName = $plan->product_name;
		$isResellerType = $plan->isResellerType();
		try {
            require_once("object_managers/ProductManager.php");
            ProductManager::delete($plan);
        } catch (ProductException $e) {
            getCurrentSession()->Storage->errorMessages[] = $e->getMessage();
            redirect("products.php", "ShowProducts");
        }
		billing_put_info(blmsg("TRANS_DELETE_PRODUCT_SUCCESS_MSG", array("NAME" => $planName)));
		if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
			redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
		} else {
			redirect("products.php", getActionID("ShowProducts"), $isResellerType ? array('reseller' => 1) : array());
		}
	}
}