<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on a todo so that that todo may be added to the 
 * database.
 *
 * @author  Mark Garrett
 */
class AddTodo extends MB_Action {
	/**
	 * The constructor for a AddTodo action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddTodo() {
		parent::MB_Action();
		$this->stringRep = "AddTodo";
	}

	/**
	 * The main method of this class that executes the AddTodo action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->smartyVars["todostatus"] = getStatuses("todo");
        $vendorId = getCurrentSession()->getVendorId();
		
        $this->setupDateSelector("todoDateDue");

        // Get Admins data for select menu
        $adminList = Factory()->AdminList(array("admin_active" => 1));
        if ($vendorId) {
            $this->_removeAllWithoutHimself($adminList, $vendorId);
        } else {
            $this->_removeAllResellers($adminList);
        }

        $this->addTemplate("todos/AddTodo");
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

    private function _removeAllResellers($adminList)
    {
		foreach ($adminList as $admin) {
            if ($admin->isReseller()) {
                continue;
            }
            $this->smartyVars["adminsList"][$admin->id] = $admin->fullName . " - " . $admin->admin_username;
		}
    }

    private function _removeAllWithoutHimself($adminList, $vendorId)
    {
        foreach ($adminList as $admin) {
            $reseller = $admin->getReseller();
            if ($vendorId != $reseller->id) {
                continue;
            }
            $this->smartyVars["adminsList"][$admin->id] = $admin->fullName . " - " . $admin->admin_username;
        }
    }
}