<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddTodo action, applies that information to  * records in the database, and redirects to the ShowTodoDetails action for the given todo.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */
class AddTodoResponse extends MB_Action {
	/**
	 * The constructor for an AddTodoResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddTodoResponse() {
		parent::MB_Action();
		$this->stringRep = "AddTodoResponse";
		$this->params = array(
			"todoTitle",
			"userID",
			"todoDesc",
			"todoStatusID",
			"todoDateDue",
			"todoAssignedAdminID",
			"todoIsPublic");
	}

	/**
	 * The main method of this class that executes the AddTodoResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF, $_REQUEST;
		parent::execute();
        
		$this->handleDateSelector("todoDateDue");
            
        $todo = Factory()->Todo();
        foreach ($this->params as $nameInput) {
            $attributeName = getDBCol($nameInput);

            if (isset($_REQUEST[$nameInput])) {
                $todo->$attributeName = $_REQUEST[$nameInput];
            } elseif ('todoIsPublic' == $nameInput) {
                $todo->$attributeName = false;
            }
        }
        $session = getCurrentSession();
        $todo->vendor_id = $session->getVendorId();
        $todo->user_id = $session->user_id;
        $todo->user_type = $session->user_type;
        
        $todo->update();
        
        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
        } else {
            redirect("todos.php", getActionID("ShowTodoDetails"), array("todoID" => $todo->todo_id));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}