<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditTodo action, applies that information to
 * records in the database, and redirects to the ShowTodoDetails action for the given todo.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */
class EditTodoResponse extends MB_Action {
	/**
	 * The constructor for an EditTodoResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditTodoResponse() {
		parent::MB_Action();
		$this->stringRep = "EditTodoResponse";
		$this->params = array(
			"todoTitle",
			"todoDesc",
			"todoStatusID",
			"todoDateDue",
			"todoAssignedAdminID",
			"todoIsPublic");
	}

	/**
	 * The main method of this class that executes the EditTodoResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		dbg("### REQUEST DATA ###");
		dbg($_REQUEST);
		
		$todoID = ((int) $_REQUEST["todoID"]);
		if(!$todoID) {
			$this->addError(TRANS_ACTIONERROR, "No todo ID given.");
		} else {
			$this->handleDateSelector("todoDateDue");
            
            $todo = Factory()->Todo($todoID);
            foreach ($this->params as $nameInput) {
                $attributeName = getDBCol($nameInput);

                if (isset($_REQUEST[$nameInput])) {
                    $todo->$attributeName = $_REQUEST[$nameInput];
                } elseif ('todoIsPublic' == $nameInput) {
                    $todo->$attributeName = false;
                }
            }
            
            $todo->update();
    		redirect("todos.php", getActionID("ShowTodoDetails"), array("todoID" => $todoID));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}