<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a Todo.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */
class RemoveTodo extends MB_Action {
	/**
	 * The constructor for a RemoveTodo action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveTodo() {
		parent::MB_Action();
		$this->stringRep = "RemoveTodo";
		$this->params = array("todoID");
	}

	/**
	 * The main method of this class that executes the RemoveTodo action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$todoID = ((int) $_REQUEST["todoID"]);
		if(!$todoID) {
			$this->addError(TRANS_ACTIONERROR, "No Todo ID given.");
		} else {
            $todo = Factory()->TodoList(array('todo_id' => $todoID, 'vendor_id' => getCurrentSession()->getVendorId()));
			if (empty($todo[0])) {
                $this->addError(TRANS_ACTIONERROR, "Todo not found.");
            } else {
                $todo = $todo[0];
				$this->smartyVars["todostatus"] = getStatuses("todo");
                $todoArray = array();
                foreach ($todo->getFields() as $attributeName => $fieldValue) {
                    $oldAttributeName = getDBXMLCol($attributeName);
                    $todoArray[$oldAttributeName][0] = $todo->$attributeName;
                }
				$this->smartyVars["todo"] = correctArray( $todoArray );
                $this->smartyVars["todo"]["admin"] = Factory()->Admin($todo->user_id);
                if (null != $todo->todo_assigned_admin_id) {
                    $this->smartyVars["todo"]["assigned"] = Factory()->Admin($todo->todo_assigned_admin_id);
                }
                
                $this->addTemplate("todos/RemoveTodo");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}