<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the RemoveTodo action, and removes the specified todo. *
 * @author  Mark Garrett
 */
class RemoveTodoResponse extends MB_Action {
	/**
	 * The constructor for an RemoveTodoResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function RemoveTodoResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveTodoResponse";
		$this->params = array("todoID");
	}

	/**
	 * The main method of this class that executes the RemoveTodoResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$todoID = ((int) $_REQUEST["todoID"]);

        $vendorId = getCurrentSession()->getVendorId();
        $todo = Factory()->TodoList(array('todo_id' => $todoID, 'vendor_id' => $vendorId));
        if (empty($todo[0])) {
            $this->addError(TRANS_ACTIONERROR, "Todo not found.");
        } else {
            $todo = $todo[0];
            $todo->delete();
            redirect("todos.php", getActionID("ShowAllTodos"));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}