<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["todoID"] it displays all
 * the details of a single todo.
 *
 * @author  Mark Garrett
 */
class ShowTodoDetails extends MB_Action {
	/**
	 * The constructor for a ShowTodoDetails object. This merely sets up our string represenation, calls 
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowTodoDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowTodoDetails";
		$this->params = array("todoID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$todoID = ((int) $_REQUEST["todoID"]);
		if(!$todoID) {
			$this->addError(TRANS_ACTIONERROR, "No Todo ID given.");
		} else {
            $todo = Factory()->TodoList(array('todo_id' => $todoID, 'vendor_id' => getCurrentSession()->getVendorId()));
			if (empty($todo[0])) {
                $this->addError(TRANS_ACTIONERROR, "Todo not found.");
            } else {
                $todo = $todo[0];
				$this->smartyVars["todostatus"] = getStatuses("todo");
                $todoArray = array();
                foreach ($todo->getFields() as $attributeName => $fieldValue) {
                    $oldAttributeName = getDBXMLCol($attributeName);
                    $todoArray[$oldAttributeName][0] = $todo->$attributeName;
                }
				$this->smartyVars["todo"] = correctArray( $todoArray );
                $this->smartyVars["todo"]["admin"] = Factory()->Admin($todo->user_id);
                if (null != $todo->todo_assigned_admin_id) {
                    $this->smartyVars["todo"]["assigned"] = Factory()->Admin($todo->todo_assigned_admin_id);
                }
                
                $this->addTemplate("todos/ShowTodoDetails");
			}
		}
		$this->addErrorTemplates();
        
		return $this->hasExecutedSuccessfully();
	}
}