<?php

require_once("admin/include/lib-action/packages/UpgradeDowngradeActionResponse.php");

class DowngradePackageResponse extends UpgradeDowngradeActionResponse
{
	public function __construct()
	{
		parent::__construct();
		global $CONF;
		loadConfigs("product", "managementrules");
		$this->stringRep = "DowngradePackageResponse";
		$this->constants = array(
			"TRANS_PRORATED_X_FEE" => TRANS_PRORATED_DOWNGRADE_FEE,
			"TRANS_ITEMIZED_X_CREDITS" => TRANS_ITEMIZED_DOWNGRADE_CREDITS,
			"TRANS_PACKAGE_X" => TRANS_PACKAGE_DOWNGRADE,
			"TRANS_PACKAGE_X_DESC" => TRANS_PACKAGE_DOWNGRADE_DESC,
			"TRANS_PACKAGE_ADDON_X" => TRANS_PACKAGE_ADDON_DOWNGRADE,
			"TRANS_PACKAGE_ADDON_X_DESC" => TRANS_PACKAGE_ADDON_DOWNGRADE_DESC,
			"TRANS_X_FEE" => TRANS_DOWNGRADE_FEE,
		);
		$this->subCommand = "panelDowngrade";
		$this->params = array("packageID");

		$clientID = $CONF["user"]["id"];

		$rules =& $CONF["product"]["managementrules"];
		$_REQUEST["packageUpgradeDowngradeType"] = ((int)$rules["whenDowngrade"]==0) ? ((int)$rules["applyDowngradeCredits"]==1 ? 0 : 1 ) : 2;
		$_REQUEST["packageProvision"] = (int)$rules["provisionDowngrades"];
		$_REQUEST["generateInvoice"] = (int)$rules["generateDowngradeInvoice"];
		$_REQUEST["packageComments"] = "";

		$_REQUEST["packagePrices"] = array(
			"original" => 0,
			"general" => 0,
			"fee" => 0,
			"coupon" => 0,
			"couponcycles" => 0,
		);

		$params = array(
			"packageID" => (int)$_REQUEST["packageID"],
			"getPackageAttributeData" => 1,
			"getPackageDatabaseData" => 1,
			"getDomainData" => 1,
			"getCertData" => 1,
			"getPackageAddonData" => 1,
		);
		if (0 != $clientID) {
			$params["clientID"] = $clientID;
		}
		$this->packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => $params,
			),
		)));

		$this->packageInfoCache[(int)$_REQUEST["packageID"]] =& $this->packageInfo;
		$packageInfo =& $this->packageInfo;

		if (!$packageInfo["packageID"]){
			$this->addError("TRANS_ACTIONERROR", "Invalid packageID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		}

		$currencyID = Factory()->Package($packageInfo["packageID"])->OrderForm->currency_id;
		$productInfo = oneOf("products", array(
			"productID" => (int)$_REQUEST["productID"],
			"productActive" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getCycleData" => 1,
		));
		$prices = array();
		if (!$productInfo["productID"]){
			$this->addError("TRANS_ACTIONERROR", "Invalid packageID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		} else {
			foreach ($productInfo["productVariantPrices"] as $p){
				if ($p["cycleID"]==$packageInfo["cycleID"] && $p["currencyID"]==$currencyID && $p["productVariantID"]==(int)$_REQUEST["productVariantID"]){
					$prices[$p["productVariantPriceType"]] = $p;
				}
			}
			$_REQUEST["packagePrices"] = array(
				"original" => BillingLocale::setNumberToInput($prices[0]["productVariantPriceAmount"]),
				"general" => BillingLocale::setNumberToInput($prices[0]["productVariantPriceAmount"]),
				"fee" => BillingLocale::setNumberToInput($prices[getAPITypeID("price", "upgradefee")]["productVariantPriceAmount"]),
			);

			$addonsInfo = arrayFor("products", array(
				"parentProductID" => $productInfo["productID"],
				"productActive" => 1,
				"getProductVariantData" => 1,
				"getProductVariantPriceData" => 1,
				"getCycleData" => 1,
			));

			foreach ($addonsInfo as $addon){
				$prices = array();
				foreach ($addon["productVariantPrices"] as $p){
					if ($p["cycleID"]==$packageInfo["cycleID"] && $p["currencyID"]==$currencyID){
						$prices[$p["productVariantPriceType"]] = $p;
					}
				}
				$_REQUEST["prices"][$addon["productID"]] = array(
					"general" => BillingLocale::setNumberToInput($prices[0]["productVariantPriceAmount"]),
					"original" => BillingLocale::setNumberToInput($prices[0]["productVariantPriceAmount"]),
					"fee" => BillingLocale::setNumberToInput($prices[getAPITypeID("price", "upgradefee")]["productVariantPriceAmount"]),
					"coupon" => 0,
					"couponcycles" => 0,
				);
			}
		}
	}
}
