{* $Id: ShowLastFiveClientPackages.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a list of package records.
 *
 * Smarty Variables:
 *	$packages (array of packages that match input criteria)
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 *}

{assign var="numCols" value="9"}

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_ID"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_PACKAGE"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_PACKAGE_TYPE"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_CYCLE"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_LAST_RENEWAL"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_NEXT_RENEWAL"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_STATUS"}

	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerName="TRANS_ACTIONS"}
</tr>
</thead>
{section name=i loop="$packages"}

{assign var="packageID" value=$packages[i].packageID}
{assign var="events" value=$packages[i].systemQueueItems}
{assign var="currencyID" value=$packages[i].currencyID}

{if $className=="alt1"}
	{assign var="className" value="alt2"}
{else}
	{assign var="className" value="alt1"}
{/if}

<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td style="cursor: pointer;" onclick="return XKtoggle('row_{$packageID}');">
	<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
		&nbsp;
		{$packageID}
	</td>
	<td>
		{$packages[i].packageName|safetyhtml}
	</td>
	<td>
		{$packages[i].packageType|getTypeName:"products"}
	</td>
	<td style="text-align:center;">
		{$packages[i].cycleID|getArrayValueByID:$cycles}
	</td>
	<td style="text-align:center;">
		{$packages[i].packageDateLastRenewal|getDate}
	</td>
	<td style="text-align:center;">
		{$packages[i].packageDateNextRenewal|getDate}
	</td>
	<td>
		{$packages[i].packageStatus|getStatusName:"package"}
	</td>
	<td>
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$packageID}');">
			<img src="{$imageDirectory}/ico/more.gif" width="16" height="16" border="0" alt="{"TRANS_VIEW"|lmsg}" title="{"TRANS_VIEW"|lmsg}" />
		</a>
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$packageID}');">
			{"TRANS_VIEW"|lmsg}
		</a>
		{/strip}
	</td>
</tr>
{if $packages[i].packageMeta.ip ||
	$packages[i].packageMeta.ipv6 ||
	$packages[i].packageMeta.domainUserName ||
	$packages[i].packageMeta.clientLogin ||
	$packages[i].packageMeta.packageUserName ||
	$packages[i].packageMeta.ftpUsername ||
	$packages[i].packageMeta.configGroupName ||
	$packages[i].packageMeta.serverGroupName ||
	$packages[i].packageMeta.domainName}
<tr>
	<td colspan="{$numCols}" style="border-bottom:1px solid #CFCDC7;">
		{if $packages[i].packageMeta.ip}
			[{"TRANS_SERVER_IP"|lmsg}&nbsp;{$packages[i].packageMeta.ip|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{/if}
		{if $packages[i].packageMeta.ipv6}
			[{"TRANS_SERVER_IP"|lmsg}&nbsp;{$packages[i].packageMeta.ipv6|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{/if}
		{if $packages[i].packageMeta.domainUserName}
			[{"TRANS_USERNAME"|lmsg}&nbsp;{$packages[i].packageMeta.domainUserName|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
			[{"TRANS_PASSWORD"|lmsg}&nbsp;{$packages[i].packageMeta.domainPassword|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{elseif $packages[i].packageMeta.clientLogin}
			[{"TRANS_USERNAME"|lmsg}&nbsp;{$packages[i].packageMeta.clientLogin|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
			[{"TRANS_PASSWORD"|lmsg}&nbsp;{$packages[i].packageMeta.clientPassword|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{elseif $packages[i].packageMeta.packageUserName}
			[{"TRANS_USERNAME"|lmsg}&nbsp;{$packages[i].packageMeta.packageUserName|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
			[{"TRANS_PASSWORD"|lmsg}&nbsp;{$packages[i].packageMeta.packagePassword|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{/if}
		{if $packages[i].packageMeta.ftpUsername}
			[{"TRANS_PACKAGE_ATTRIBUTES__FTPUSERNAME"|lmsg}&nbsp;{$packages[i].packageMeta.ftpUsername|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
			[{"TRANS_PACKAGE_ATTRIBUTES__FTPPASSWORD"|lmsg}&nbsp;{$packages[i].packageMeta.ftpPassword|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{/if}
		{if $packages[i].packageMeta.configGroupName}
			[{"TRANS_PANEL_SERVERNAME_OPTION"|lmsg}&nbsp;{$packages[i].packageMeta.configGroupName|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{/if}
		{if $packages[i].packageMeta.serverGroupName}
			[{"TRANS_SERVER_GROUP_OPTION"|lmsg}&nbsp;{$packages[i].packageMeta.serverGroupName|default:$smarty.const.TRANS_UNKNOWN}]&nbsp;&nbsp;&nbsp;
		{/if}
		{if $packages[i].packageMeta.domainName}
			[{"TRANS_DOMAIN"|lmsg}&nbsp;{$packages[i].packageMeta.domainName}]&nbsp;&nbsp;&nbsp;
		{/if}
	</td>
</tr>
{/if}
</tbody>
<tbody id="row_{$packageID}" class="off">
<tr>
	<td colspan="{$numCols}" class="solid">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$packageID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
			</a>
		&nbsp;

		<strong>{"TRANS_ADDITIONAL_ACTIONS"|lmsg}</strong>
		&nbsp;

		{* DETAILS *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="ShowPackageDetails"
			args="packageID=$packageID"
			icoImage="view"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_DETAILS"
			titleText=""
			linkText="TRANS_DETAILS"
			noSpace="1"
		}
		&nbsp;

		{* EDIT *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="EditPackage"
			args="packageID=$packageID"
			icoImage="edit"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_EDIT"
			titleText=""
			linkText="TRANS_EDIT"
			noSpace="1"
		}
		&nbsp;

		{if $packages[i].canUpgrade}
			{* UPGRADE *}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="packages.php"
				actionName="UpgradePackage"
				args="packageID=$packageID"
				icoImage="upgrade.gif"
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_UPGRADE"
				titleText=""
				linkText="TRANS_UPGRADE"
				noSpace="1"
			}
			&nbsp;
		{/if}

		{if $packages[i].canDowngrade}
			{* DOWNGRADE *}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="packages.php"
				actionName="DowngradePackage"
				args="packageID=$packageID"
				icoImage="downgrade.gif"
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_DOWNGRADE"
				titleText=""
				linkText="TRANS_DOWNGRADE"
				noSpace="1"
			}
			&nbsp;
		{/if}

		{* ATTRIBUTES *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="ShowPackageAttributes"
			args="packageID=$packageID"
			icoImage="cube_molecule.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_ATTRIBUTES"
			titleText=""
			linkText="TRANS_ATTRIBUTES"
			noSpace="1"
		}
		&nbsp;

		{* ADDONS *}
        {if $packages[i].packageType != $resellerProductType}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="ShowPackageAddons"
			args="packageID=$packageID"
			icoImage="cubes_other.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_ADDONS"
			titleText=""
			linkText="TRANS_ADDONS"
			noSpace="1"
		}
		&nbsp;
        {/if}

		{if $packages[i].canTransfer}
		{* MOVE PACKAGE *}
		<a href="javascript:void(0);" onclick="return overlib('&lt;div style=\'white-space: nowrap\'&gt;
			&lt;form method=\'post\' action=\'{getFormAction controller="packages"}\'&gt;
			&lt;input type=\'hidden\' name=\'act\' value=\'{getActionID action="ChangePackageClient"}\' /&gt;
			&lt;input type=\'hidden\' name=\'packageID\' value=\'{$packageID}\' /&gt;
			&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\' /&gt;
			{"TRANS_CLIENT_ID"|lmsg}&nbsp;&lt;input type=\'text\' name=\'clientID\' value=\'{$editValue}\' onClick=\'javascript:this.form.editValue.focus();this.form.editValue.select();\' /&gt;
			&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_TRANSFER"|lmsg}\' /&gt;
			&lt;/form&gt;&lt;/div&gt;',
			BGCLASS, 'popupBG',
			FGCLASS, 'popupFG',
			CAPTIONFONTCLASS, 'popupCaption',
			CENTER, STICKY,
			CAPTION, '{"TRANS_MOVE_PACKAGE"|lmsg} {$packageID}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
			<img src="{$imageDirectory}/ico/arrow_right_blue.gif" alt="{"TRANS_TRANSFER"|lmsg}" title="{"TRANS_MOVE"|lmsg}" />
		</a>
		&nbsp;
		<a href="javascript:void(0);" onclick="return overlib('&lt;div style=\'white-space: nowrap\'&gt;
			&lt;form method=\'post\' action=\'{getFormAction controller="packages"}\'&gt;
			&lt;input type=\'hidden\' name=\'act\' value=\'{getActionID action="ChangePackageClient"}\' /&gt;
			&lt;input type=\'hidden\' name=\'packageID\' value=\'{$packageID}\' /&gt;
			&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\' /&gt;
			{"TRANS_CLIENT_ID"|lmsg}&nbsp;&lt;input type=\'text\' name=\'clientID\' value=\'{$editValue}\' onClick=\'javascript:this.form.editValue.focus();this.form.editValue.select();\' /&gt;
			&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_TRANSFER"|lmsg}\' /&gt;
			&lt;/form&gt;&lt;/div&gt;',
			BGCLASS, 'popupBG',
			FGCLASS, 'popupFG',
			CAPTIONFONTCLASS, 'popupCaption',
			CENTER, STICKY,
			CAPTION, '{"TRANS_TRANSFER_PACKAGE"|lmsg} {$packageID}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
			{"TRANS_TRANSFER_PACKAGE"|lmsg}
		</a>
		{/if}

		{/strip}
	</td>
</tr>

<style>
{literal}
.comments td {padding: 4px;}
.comments .b-panel-content-wrap td {padding-left: 10px!important; }
{/literal}
</style>

<tr class="comments">
	<td colspan="{$numCols}" class="comments altinner">
		<table cellpadding="0" cellspacing="0">
		<tr>
			<td width="50%" style="vertical-align: top">
				{* COLUMN 1a *}
				{if ! $client}
					<div id="main-wrapper" style="margin: 0px!important;">
						<div class="b-grid">
							<div class="b-grid-item" style="width: 100%!important;">
								<div class="b-panel">
									<div class="b-panel-wrap">
										<div class="b-panel-title">
											<div class="b-panel-title-wrap">
											<b>
												{"TRANS_CLIENT_ID"|lmsg} {$packages[i].clientID}&nbsp;&nbsp;
												<a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=`$packages[i].clientID`"}">
													<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{"TRANS_DETAILS"|lmsg}" title="{"TRANS_DETAILS"|lmsg}" />
												</a>
											</b>
											</div>
										</div>
										<div class="b-panel-content">
											<div class="b-panel-content-wrap">
												<table width="100%" border="0" cellpadding="0" cellspacing="0">
												<tr>
													<td width="80" nowrap="nowrap"><strong>{"TRANS_COMPANY"|lmsg}</strong></td>
													<td>{$packages[i].clientCompany|safetyhtml|default:$smarty.const.TRANS_EMPTY}</td>
												</tr>
												<tr>
													<td nowrap="nowrap"><strong>{"TRANS_NAME"|lmsg}</strong></td>
													<td>{$packages[i].contactLastName|safetyhtml}, {$packages[i].contactFirstName|safetyhtml}</td>
												</tr>
												</table>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<br />
				{/if}
				{* COLUMN 1b *}
				<div id="main-wrapper" style="margin: 0px!important;">
					<div class="b-grid">
						<div class="b-grid-item" style="width: 100%!important;">
							<div class="b-panel">
								<div class="b-panel-wrap">
									<div class="b-panel-title">
										<div class="b-panel-title-wrap">
										<b>
											{"TRANS_PRODUCT_ID"|lmsg} {$packages[i].productID}&nbsp;&nbsp;
											<a href="{getAdminActionUrl module="products" controller="plan-overview"}&id={$packages[i].productID}">
												<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{"TRANS_DETAILS"|lmsg}" title="{"TRANS_DETAILS"|lmsg}" />
											</a>
										</b>
										</div>
									</div>
									<div class="b-panel-content">
										<div class="b-panel-content-wrap">
											<table width="100%" border="0" cellpadding="0" cellspacing="0">
												<tr>
													<td width="80" nowrap="nowrap"><strong>{"TRANS_NAME"|lmsg}</strong></td>
													<td>{$packages[i].productName|safetyhtml}</td>
												</tr>
												<tr>
													<td nowrap="nowrap"><strong>{"TRANS_COMMENTS"|lmsg}</strong></td>
													<td>{$packages[i].productComments|stripslashes|html_entity_decode}</td>
												</tr>
												{if $packages[i].domains.0.domainSLD}
													{assign var="domain" value=$domains.$packageID}
													<tr>
														<td nowrap="nowrap"><strong>{"TRANS_DOMAIN_NAME_OPTION"|lmsg}</strong></td>
														<td>{$packages[i].domains.0.domainSLD}.{$packages[i].domains.0.domainTLD}</td>
													</tr>
												{/if}
											</table>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</td>
			<td width="50%" style="vertical-align: top">
				{* COLUMN 2 *}
				<div id="main-wrapper" style="margin: 0px!important;">
					<div class="b-grid">
						<div class="b-grid-item" style="width: 100%!important;">
							<div class="b-panel">
								<div class="b-panel-wrap">
									<div class="b-panel-title">
										<div class="b-panel-title-wrap">
										<b>{"TRANS_GENERAL_RENEWAL_DATES"|lmsg}</b>
										</div>
									</div>
									<div class="b-panel-content">
										<div class="b-panel-content-wrap">
											<table width="100%" border="0" cellpadding="0" cellspacing="0">
												<tr>
													<td width="80" nowrap="nowrap"><strong>{"TRANS_CYCLE"|lmsg}</strong></td>
													<td>{$packages[i].cycleID|getArrayValueByID:$cycles}</td>
												</tr>
												<tr>
													<td nowrap="nowrap"><strong>{"TRANS_ENTERED_OPTION"|lmsg}</strong></td>
													<td>{$packages[i].packageDateCreated|getDateTime}</td>
												</tr>
												<tr>
													<td nowrap="nowrap"><strong>{"TRANS_PACKAGE_ACTIVATION_DATE_OPTION"|lmsg}</strong></td>
													<td>{$packages[i].packageDateBeginRenewal|getDateTime}</td>
												</tr>
												<tr>
													<td nowrap="nowrap"><strong>{"TRANS_PACKAGE_DATE_NEXT_RENEWAL"|lmsg}</strong></td>
													<td>{$packages[i].packageDateNextRenewal|getDateTime}</td>
												</tr>
												<tr>
													<td nowrap="nowrap"><strong>{"TRANS_PACKAGE_DATE_LAST_RENEWAL"|lmsg}</strong></td>
													<td>{$packages[i].packageDateLastRenewal|getDateTime}</td>
												</tr>
												<tr>
													<td nowrap="nowrap"><strong>{"TRANS_EXPIRATION_DATE_OPTION"|lmsg}</strong></td>
													<td>{$packages[i].packageDateStopRenewal|getDateTime}</td>
												</tr>
											</table>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</td>
		</tr>
		</table>
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="{$numCols}">{"TRANS_NORESULTS"|lmsg}</td>
</tr>
{/section}
</table>

