<?php

class BillingCheckoutService extends BillingService {
	
	protected static $instance = null;
    const E_FAIL_OPERATION_ERROR = 5;
	
	public function executeCheckout($storeId, $cartData, $customerData, $clientId = null, $extraSiteBuilderParams = array()) {
		$response = $this->executeProcessCheckout($storeId, $cartData, $customerData, $clientId, $extraSiteBuilderParams);
		if ($response->hasErrors()) {
            foreach ($response->getErrors() as $error) {
                $key = key($error);
                if (self::E_FAIL_OPERATION_ERROR == $key) {
                    throw new BillingFormException($error[$key]);            
                }
                throw new BillingServiceException('Can not checkout form Store with id "' . $storeId . '"');
            }
		} else {
			return $response->getData();
		}
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('checkout'));
		}
		return self::$instance;
	}
	
}